# Market Metadata

The Comptroller contract has an array called `allMarkets` that contains the addresses of each sToken contract. Each address in the `allMarkets` array can be used to fetch a metadata struct in the Comptroller’s markets constant. See the [Comptroller Storage contract](https://github.com/strike-finance/strike-protocol/blob/master/contracts/ComptrollerStorage.sol) for the Market struct definition.

**Comptroller**

```
SToken[] public allMarkets;
```

**Solidity**

```
Comptroller troll = Comptroller(0xABCD...);
SToken sTokens[] = troll.allMarkets();
```

**Web3 1.2.6**

```javascript
const comptroller = new web3.eth.Contract(comptrollerAbi, comptrollerAddress);
const sTokens = await comptroller.methods.allMarkets().call();
const sToken = sTokens[0]; // address of a sToken
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.strike.org/comptroller/market-metadata.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
